clear all
close all
clc
%% Data loading
% load('.\Data\nms_0_Struct_001.mat');
% load('.\Data\GoPro\GoPro_Right_Red\GX010103\ParaBoundary\origin\nms_1_Struct_1998_2018_boiNum_1_FUSION.mat');

load('.\Data\GoPro\GoPro_Right_Red\GX010103\ParaBoundary\origin\nms_1_Struct_2048_2078_boiNum_1.mat'); % FUSION trial

edgepath = '..\image\GoPro\edge\GoPro_Right_Red\GX010103\origin\';
imgpath = '..\image\GoPro\image\GoPro_Right_Red\GX010103\origin\';


%% Video
% videoname  = ['.\Data\GoPro\GoPro_Right_Red\GX010103\Workshop_Video\lineFit_Rec_GX010103'];
% writerObj = VideoWriter(videoname);
% Total_time  = 100; % total time of video in seconds
% framerate = 2;
% writerObj.FrameRate = framerate;
% open(writerObj);


%% The size of the filter
step = 5; %5 step ahead, make sure step<dimY
seg_num = 20;  % Will be changed later
dimY = 5;  % size of each piece of image

Sample = 100;
%% Number of BOI
% boi_Num = 3; % 1 more than wanted to make sure passing the enclosure check

% startFrame = 1998;
% endFrame = 2018;

% For FUSION trial
startFrame = 2048;
endFrame = 2048;

% f1 = figure('units','normalized','outerposition',[0 0 1 1]);
for i = startFrame:1:endFrame
    figure(i)
    boi_Num = 1; % 1 more than wanted to make sure passing the enclosure check 
    tempFrame = nms_1_Struct(i).label;
%     imshow(tempFrame);
    
    %% Exclude those short boundaries
    tempCoor = nms_1_Struct(i).coor;
    B_Coor = [];
    B_Size = [];
    for loop = 1:1:size(tempCoor,1)
        B_Coor = tempCoor{loop,1};
        B_Size(loop) = size(B_Coor,1);
    end


    [totalV, totalIndex] = sort(B_Size, 'descend');  % Rearrange the size in descending order
    
    copy_tempFrame = tempFrame; % A copy of the temporal frame
    
    %% Boundaries of interest (BOI), we only choose two of them
    targetIndex = totalIndex(1,1:boi_Num);
    

 %%
    
    boi_Num = length(targetIndex);
    for boi_loop = 1:1:boi_Num
            flag = nms_1_Struct(i).coor{targetIndex(1,boi_loop),1}(1,:);
            flag_V(1,boi_loop) = tempFrame(flag(1,1),flag(1,2));
    end

   
    for row = 1:1:size(tempFrame,1)
        for col = 1:1:size(tempFrame,2)
            FLAG = 0;
            for boi_loop = 1:1:boi_Num
                if tempFrame(row,col) == flag_V(1,boi_loop)
                    FLAG = 1;
                    break;
                end
            end
            if FLAG == 0
                tempFrame(row,col) = 0;
            end          
        end
    end
    
    %% Read edge
    read_edge_name = [edgepath 'im_' num2str(i) '.png'];
    edge_pic = imread(read_edge_name);
    
    %% Read image
    read_image_name = [imgpath 'im_' num2str(i) '.png'];
    image_pic = imread(read_image_name);
     
    [minX, maxX, minY, maxY] = findcorners(tempFrame);
    hold on
    imshow(image_pic);
    hold on
    %% ICASSP Boundaries draw
    colors=['b' 'g' 'r' 'c' 'm' 'y'];    
   for k=1:length(targetIndex)
      boundary_1 =  tempCoor{targetIndex(1, k)};
      cidx = mod(k,length(colors))+1;
      plot(boundary_1(:,2), boundary_1(:,1),...
           colors(cidx),'LineWidth',2);
    end
   
    if maxY - minY <= dimY
        seg_num = 1;
    else
        seg_num = floor((maxY - minY - dimY) / step);
    end

w_e = 2704;
h_e = step;

    for j = 1:1:seg_num
        subFrame = tempFrame(  (minY + (j-1)*step):((minY + (j-1)*step) + dimY), minX:maxX);

         [B, L, N, A] = bwboundaries(subFrame);
        if size(B,1) <2
            continue;
        elseif size(B,1) > 2
             pts = [];
             for k = 1:1:size(B,1) % Collect all the data points of the boundaries
                 pts = [pts; B{k, 1}];
             end
             [Idx, C] = kmeans(pts, 2);
             newPts_1 = pts(find(Idx==1), :);
             newPts_2 = pts(find(Idx==2), :);   
%              B = cell(2,1);
%              B{1,1} = newPts_1;
%              B{2,1} = newPts_2;
             num_12 = min(size(newPts_1,1), size(newPts_2,1));
             sampNum = floor(num_12/2) + floor(num_12/4);
             sampMat_1 = randi(size(newPts_1,1), [sampNum, Sample]); % Change 5 to get  various number of line segments
             sampMat_2 = randi(size(newPts_2,1), [sampNum, Sample]);
             for k = 1:1:2
                  min_ey = min(pts(:,2));
                  max_ey = max(pts(:,2));

                  min_ex = min(pts(:,1));
                  max_ex = max(pts(:,1)) ;

                  pos = [min(min_ex,0) minY + (j-1)*step w_e h_e];
                  rectangle('Position',pos,'EdgeColor','w','LineWidth',0.5);
                  hold on      

                  for k_1 = 1:1:Sample
                      if k == 1
                          tempPts = newPts_1(sampMat_1(:,k_1), :);
                      else
                          tempPts = newPts_2(sampMat_2(:,k_1), :);;
                      end

                      y = tempPts(:,2) + minX;
                      x = tempPts(:,1) + (minY + (j-1)*step);

                      tempLine = polyfit(x, y, 1);
                      y_est = polyval(tempLine, x);
                      hold on
                      plot(  y_est - 1 , x, 'k','LineWidth',3);

                      Line(j).line(k).y_est(k_1).y_est = y_est;
                      Line(j).line(k).x(k_1).x = x;
                      Line(j).line(k).para(k_1).para = tempLine;
                  end
             end
        else
            pts_1 = B{1,1};
            pts_2 = B{2,1};
            num_1 = size(pts_1,1);
            num_2 = size(pts_2,1);
            num_11 = min(num_1, num_2);
            sampNum = floor(num_11/2) + floor(num_11/4);
             for k = 1:1:2
                    pts = B{k,1};   %% pts(:,1) is y, pts(:,2) is x

                    y = pts(:,2) + minX;
                    x = pts(:,1) +  (minY + (j-1)*step);
                    
                    min_ey = min(y);
                    max_ey = max(y);
                    
                    min_ex = min(x);
                    max_ex = max(x) ;
                    
                    hold on
                    pos = [min(min_ex,0) minY + (j-1)*step w_e h_e];
                    rectangle('Position',pos,'EdgeColor','w','LineWidth',0.5);
                    hold on

                    sampMat = randi(size(pts,1), [sampNum, Sample]); % Change 10 to get  various number of line segments
                    
                   for k_1 = 1:1:Sample 
                        temp_x = x(sampMat(:,k_1),:);
                        temp_y = y(sampMat(:,k_1),:);
                        tempLine = polyfit(temp_x, temp_y, 1);
                        y_est = polyval(tempLine, temp_x);
                        plot( y_est - 1 , temp_x, 'k','LineWidth',3);
                        hold on
                        
                        Line(j).line(k).y_est(k_1).y_est = y_est;
                        Line(j).line(k).x(k_1).x = x;
                        Line(j).line(k).para(k_1).para = tempLine;
                   end

%                     hold on
             end
         end
    end
cellLine{i,1} = Line;
cellLine{i,2} = [minX minY; maxX maxY];
%% Video
% F = imcapture(f1);
% writeVideo(writerObj,F);

end
%  close(writerObj);  

